
function getNewTEIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode(propertyPathForTE+'entries');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function saveEntryForSimulation(sValue) {
    // determinate the ID
    var oParameterObject = JSON.parse(unescape(sValue));
    
    var idValue = null;
    if (oParameterObject.id != null)
        idValue = oParameterObject.id;
    else
        idValue = getNewTEIdValue();
    oParameterObject.id=idValue;
    
    if (oParameterObject.time!=null)
        if (oParameterObject.time.timeBase!=null) {
            if (oParameterObject.time.timeBase=='beforeHoliday')
                oParameterObject.time.propertyReference=propertyPathForPS+"values/holiday/*/von";
            if (oParameterObject.time.timeBase=='afterHoliday')
                oParameterObject.time.propertyReference=propertyPathForPS+"values/holiday/*/bis";
        }
    // store the entry in ps as value for simulation 
    setSimValueForID(idValue,true);
    Property.store();
    // let the te save the normal parameter ... that will trigger a system-addon-timed-events.saved event, which should update the state-entries 
    var sNewValue = escape(JSON.stringify(oParameterObject));
    var evt = new Event("system-addon-timed-events.config", {actions:'save',value:sNewValue});
    evt.raise();

}

function deleteTEEntry(id) {
    // delete local Entry
    lInfo.logln('Loesche ID ' + id);
    var baseNode = Property.getNode('entries');
    if (baseNode != null)
        baseNode.removeChild(id);
    Property.store();
    // trigger a te-delete event ... that will trigger a timed-events.saved event, which should update the UI
    var evt = new Event("system-addon-timed-events.config", {actions:'delete',id:id});
    evt.raise();    
}

// ------------ Holiday Zeug

function getNewHolidayIdValue() {
    var idValue = 0;
    var baseNode = Property.getNode('values/holiday');
    if (baseNode == null)
        return idValue;
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
        var oChildNode = oArrayNode[iIndex];
        if (oChildNode.getChild('id') != null)
            if (oChildNode.getChild('id').getValue() != null)
                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
    }
    return idValue;
}

function storeHolidayParameter(path, value) {
    try 
    {
        lInfo.logln("storeHolidayParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty('values/holiday/' + path, value);
        Property.setFlag('values/holiday/' + path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim storeHolidayParameter " + e + " Path " + path  + " value " + value);
    }        
}

function storeHolidayValue(sValue) {
    try {
        var oParameterObject = JSON.parse(unescape(sValue));

        var idValue = null;
        if (oParameterObject.id != null)
            idValue = oParameterObject.id;
        else
            idValue = getNewHolidayIdValue();

        var baseNode = Property.getNode('values/holiday');
        if (baseNode != null)
            baseNode.removeChild(idValue);

        storeHolidayParameter(idValue + '/name', Utf8.encode(unescape(oParameterObject.name)));
        storeHolidayParameter(idValue + '/id', idValue);

        storeHolidayParameter(idValue + '/von', Math.floor((new Date(oParameterObject.von)).getTime()/1000));
        storeHolidayParameter(idValue + '/bis', Math.floor((new Date(oParameterObject.bis)).getTime()/1000));
    
        var evt = new Event("system-addon-timed-events.config", {actions:'updateTimer'});
        evt.raise();
        
    } catch (e) {
        lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
            l.logln(i + ': ' + e[i]);
        }
    }
}



if (raisedEvent.name == 'system-addon-timed-events.saved') {
    syncTEWithPS();
}


if (raisedEvent.name == 'system-addon-presence-simulator.te-config') {
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("PS-Config TE delete value " + raisedEvent.parameter.id);
        deleteTEEntry(raisedEvent.parameter.id);
    }
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("PS-Config TE param value " + raisedEvent.parameter.value);       
        saveEntryForSimulation(raisedEvent.parameter.value);
    }       
    if (raisedEvent.parameter.actions == 'syncTE') {
        lInfo.logln("PS-Config SYNC TE with PS");       
        syncTEWithPS();
    }
    if (raisedEvent.parameter.actions == 'syncPS') {
        lInfo.logln("PS-Config SYNC PS with TE");       
        syncPSWithTE();
    }
    if (raisedEvent.parameter.actions == 'setStateForHoliday') {
        lInfo.logln("PS-Config Set State for !!!! Holiday: "+ raisedEvent.parameter.id);   
        setSimValueForID(raisedEvent.parameter.id,true);
        syncTEWithPS();
    }
    if (raisedEvent.parameter.actions == 'resetStateForHoliday') {
        lInfo.logln("PS-Config Reset State for !!! Holiday: "+ raisedEvent.parameter.id);
        setSimValueForID(raisedEvent.parameter.id,false);
        syncTEWithPS();
    }
    
}


if (raisedEvent.name == 'system-addon-presence-simulator.holiday-config') {
    if (raisedEvent.parameter.actions == 'save') {
        lInfo.logln("PS-Config Holiday param value " + raisedEvent.parameter.value);       
        var id=storeHolidayValue(raisedEvent.parameter.value);
        Property.store();   

        var evt = new Event("system-addon-presence-simulator",  {actions:'checkHoliday'});
        evt.raise();

        var evt2 = new Event("system-addon-presence-simulator.saved", {id:id});
        evt2.raise();
    }
    if (raisedEvent.parameter.actions == 'delete') {
        lInfo.logln("PS-Config Holiday delete value " + raisedEvent.parameter.id);

        var baseNode = Property.getNode('values/holiday');
        if (baseNode != null)
            baseNode.removeChild(raisedEvent.parameter.id);
        
        Property.store();

        var evt = new Event("system-addon-presence-simulator",  {actions:'checkHoliday'});
        evt.raise();

        var evt2 = new Event("system-addon-presence-simulator.saved",  {id:raisedEvent.parameter.id});
        evt2.raise();
    }
}
    
